<?php
use services\navigation\MenuItem;

if ( !defined( 'IN_CMS' ) ) {
    exit();
}

\IoC::resolve( 'eventmediator' )->attach( 'before_route', function( FastRoute\RouteCollector $r, $request, $response ) {
    $r->addRoute( 'GET', 'language/{language:\\w+}', 'plugins\\language_switcher\\controllers\\LanguageController@change' );
    return true;
} );

\IoC::resolve( 'eventmediator' )->attach( 'after_initialize_backend_menu', function( services\navigation\Menu $backendMenu ) {
    $backendMenu->addItem( new MenuItem( 'language', '#' ) );
    $locales = include( dirname( __FILE__ ) . DS . 'config' . DS . 'locales.php' );
    foreach ( $locales as $key => $value ) {
        $backendMenu->getItems()['language']->addChild( new MenuItem( $value, BASE_URL . 'language/' . $key ) );
    }
    return true;
} );

\IoC::resolve( 'eventmediator' )->attach( 'before_render', function( $controller, $request, $response ) {
    $latte = \IoC::resolve( 'view' )->getLatte();
    $latte->getLoader()->addLoader( new LatteFileLoader( dirname( __FILE__ ) . DS . TEMPLATES_DIR ) );
    $controller->locales = include( dirname( __FILE__ ) . DS . 'config' . DS . 'locales.php' );
    return true;
} );

$logger = \IoC::resolve( 'logger' );
$logger->info( 'Plugin language_switcher initialized.' );
